<template>
  <v-container>
    <v-row align="center" justify="center">
      <div id="map" data-cy="map-location"></div>
    </v-row>
  </v-container>
</template>
<script>
export default {
  data() {
    return {
      map: null,
      tileLayer: null,
      coords: [],
      info: [],
      data: {},
      currentUser: '',
      currentUserEmail: ''
    }
  },
  beforeMount() {
    this.getCoords()
  },
  mounted() {
    this.initMap()
  },
  methods: {
    /* eslint new-cap: ["error", { "newIsCap": false }] */
    initMap() {
      this.map = L.map('map', {
        center: [21.5090287, -95.9996143, 3],
        zoom: 2.6
      })
      this.tileLayer = new L.tileLayer(
        'https://server.arcgisonline.com/ArcGIS/rest/services/NatGeo_World_Map/MapServer/tile/{z}/{y}/{x}',
        {
          attribution:
            'Tiles &copy; Esri &mdash; National Geographic, Esri, DeLorme, NAVTEQ, UNEP-WCMC, USGS, NASA, ESA, METI, NRCAN, GEBCO, NOAA, iPC',
          maxZoom: 15
        }
      )
      this.tileLayer.addTo(this.map)
      this.getData()
    },
    getCoords() {
      return this.$firebase
        .firestore()
        .collection('mapDataCollection')
        .get()
    },
    getData() {
      const self = this
      this.getCoords().then(function(response) {
        response.forEach((doc) => {
          self.data = {
            ref: doc.ref.path,
            ...doc.data()
          }
          self.coords.push([self.data.latitude, self.data.longitude])
          self.info.push(self.data)
        })
        self.setMarkers()
      })
    },
    setMarkers() {
      const self = this
      self.coords.forEach((element, index) => {
        L.marker(element)
          .addTo(self.map)
          .bindPopup(
            `País: ${self.info[index].country} <br> Ciudad: ${
              self.info[index].city
            } <br> C.P. ${self.info[index].postal} <br> Longitud: ${
              self.info[index].longitude
            } <br> Latitud: ${self.info[index].latitude} <br> Verificación: ${
              self.info[index].verified ? 'Exitosa' : 'Fallida'
            }`
          )
      })
    }
  }
}
</script>
<style>
body,
html {
  height: 100%;
}
#map {
  width: 960px;
  height: 500px;
}
.v-navigation-drawer--clipped:not(.v-navigation-drawer--temporary):not(.v-navigation-drawer--is-mobile) {
  z-index: 1002;
}
</style>
